COMMENT * Jedi Knight ASM DLL
#
# ADVAPI32.ASM
#
# MASM Source - Jedi Knight Registry Redirector - version 1.3
#
# Redirects Jedi Knight's registry calls to a configuration file (JK.ini).
#
# 32601 is 16300 (max registry value size on Win9x) doubled plus one.
#
# [QM]
#
# (C) 1997 LucasArts Entertainment Co. All Rights Reserved
* ========================================================================================

;symbols

echo :cmd
echo set _=d

.386
.model flat,stdcall
option casemap:none

include windows.inc
include kernel32.inc
includelib kernel32.lib

HexEncode PROTO :DWORD,:DWORD,:DWORD
HexDecode PROTO :DWORD,:DWORD

.data
DblZero db "00"
NoValue db 0
AppName db "Jedi Knight",0
IniPath db MAX_PATH dup(0),0
IniFile db "JK.ini",0

.data?
IniBuff db 32601 dup(?)

;end

; ========================================================================================

.code

DllMain proc uses edi hinstDLL:HINSTANCE, fdwReason:DWORD, lpvReserved:LPVOID
	.if fdwReason == DLL_PROCESS_ATTACH
		mov	edi, offset IniPath
		invoke	GetModuleFileName, NULL, edi, MAX_PATH
		add	edi, eax
		xchg	ecx, eax
		mov	al, "\"
		std
		repne	scasb
		cld
		mov	byte ptr [edi+2], 0
		invoke	lstrcat, offset IniPath, offset IniFile
	.endif
	mov	eax, TRUE
	ret
DllMain endp

; ........................................................................................

RegCloseKey proc hKey:DWORD
	mov	eax, ERROR_SUCCESS
	ret
RegCloseKey endp

RegCreateKeyExA proc hKey:DWORD, lpSubKey:DWORD, xReserved:DWORD, lpClass:DWORD, dwOptions:DWORD, samDesired:DWORD, lpSecurityAttributes:DWORD, phkResult:DWORD, lpdwDisposition:DWORD
	mov	phkResult, NULL
	mov	lpdwDisposition, REG_OPENED_EXISTING_KEY
	mov	eax, ERROR_SUCCESS
	ret
RegCreateKeyExA endp

RegDeleteKeyA proc hKey:DWORD, lpSubKey:DWORD
	mov	eax, ERROR_SUCCESS
	ret
RegDeleteKeyA endp

RegOpenKeyExA proc hKey:DWORD, lpSubKey:DWORD, ulOptions:DWORD, samDesired:DWORD, phkResult:DWORD
	mov	phkResult, NULL
	mov	eax, ERROR_SUCCESS
	ret
RegOpenKeyExA endp

; ........................................................................................

RegQueryValueExA proc hKey:DWORD, lpValueName:DWORD, lpReserved:DWORD, lpType:DWORD, lpData:DWORD, lpcbData:DWORD
	mov	eax, offset IniPath
	movzx	eax, byte ptr [eax]
	.if eax != 0
		invoke	GetPrivateProfileString, offset AppName, lpValueName, offset NoValue, offset IniBuff, 32601, offset IniPath
		mov	eax, offset IniBuff
		movzx	eax, byte ptr [eax]
		.if eax != 0
;			invoke	lstrlen, offset IniBuff
;			shr	eax, 1
;			mov	lpcbData, eax
			invoke	HexDecode, offset IniBuff, lpData
;			mov	lpType, REG_BINARY
			mov	eax, ERROR_SUCCESS
		.else
			mov	eax, ERROR_FILE_NOT_FOUND
		.endif
	.else
		mov	eax, ERROR_FILE_NOT_FOUND
	.endif
	ret
RegQueryValueExA endp

; ........................................................................................

RegSetValueExA proc hKey:DWORD, lpValueName:DWORD, xReserved:DWORD, dwType:DWORD, lpData:DWORD, cbData:DWORD
	mov	eax, offset IniPath
	movzx	eax, byte ptr [eax]
	.if eax != 0
		.if dwType == REG_SZ
			invoke	HexEncode, lpData, cbData, offset IniBuff
			invoke	lstrcat, offset IniBuff, offset DblZero
			invoke	WritePrivateProfileString, offset AppName, lpValueName, offset IniBuff, offset IniPath
		.elseif dwType == REG_BINARY
			invoke	HexEncode, lpData, cbData, offset IniBuff
			invoke	WritePrivateProfileString, offset AppName, lpValueName, offset IniBuff, offset IniPath
		.endif
	.endif
	mov	eax, ERROR_SUCCESS
	ret
RegSetValueExA endp

; ........................................................................................
; HexEncode, pBuff, dwLen, pOutBuff
;
; Converts binary data into a hex string.
; Parameters:
;    pBuff - in/required - pointer to buffer containing binary data
;    dwLen - in/required - length of pBuff
;    pOutBuff - out/required - pointer to buffer to accept hex string
;
; Author: Jake Commander
; Copyright The GeneSys Development System
; ........................................................................................
HexEncode proc uses edi esi ebx pBuff:DWORD, dwLen:DWORD, pOutBuff:DWORD
	mov	ebx, dwLen
	mov	edi, pOutBuff
	test	ebx, ebx
	mov	esi, pBuff
	jz	@F
	.repeat
		movzx	eax, byte ptr [esi]
		mov	ecx, eax
		add	edi, 2
		shr	ecx, 4
		and	eax, 1111b
		and	ecx, 1111b
		cmp	eax, 10
		sbb	edx, edx
		adc	eax, 0
		lea	eax, [eax+edx*8+'7']
		cmp	ecx, 10
		sbb	edx, edx
		adc	ecx, 0
		shl	eax, 8
		lea	ecx, [ecx+edx*8+'7']
		or	eax, ecx
		inc	esi
		mov	[edi-2], ax
		dec	ebx
	.until ZERO?
@@:	mov	eax, edi
	mov	byte ptr [edi], 0
	sub	eax, pOutBuff
	ret
HexEncode endp

; ........................................................................................
; HexDecode, pHexStr, pOutBuffer
;
; Converts a hex string into binary data.
; Parameters:
;    pHexStr - in/required - pointer to buffer containing hex string
;    pOutBuffer - out/required - pointer to buffer to accept binary data
;
; Author: Jake Commander
; Copyright The GeneSys Development System
; ........................................................................................
HexDecode proc uses esi edi ebx pHexStr:DWORD, pOutBuffer:DWORD
	mov	esi, pHexStr
	mov	edi, pOutBuffer
	jmp	@1
@@:	and	ebx, 0Fh
	add	eax, ebx
	mov	[edi], al
	inc	edi
@1:	movzx	edx, byte ptr[esi]
	cmp	edx, 40h
	sbb	ebx, ebx
	sub	edx, 37h
	and	ebx, 7
	inc	esi
	add	ebx, edx
	js	@F
	mov	eax, ebx
	shl	eax, 4
	mov	[edi], al
	movzx	edx, byte ptr [esi]
	cmp	edx, 40h
	sbb	ebx, ebx
	sub	edx, 37h
	and	ebx, 7
	inc	esi
	add	ebx, edx
	jns	@B
@@:	ret
HexDecode endp

; ........................................................................................

end DllMain
